----------------------------------
-- THE SPECIALISTS MODE 0.7
-- by mikade
----------------------------------

-- version history
-----------------
-- version 0.1
-----------------
-- concept test

----------------
-- version 0.2
----------------
-- added gfRandomOrder to gameflags
-- removed some deprecated variables/methods
-- fixed lack of portal reset

----------------
-- version 0.3
----------------
-- added switching on start
-- removed switch from engineer weaponset

----------------
-- version 0.4
----------------
-- Attempted to:
-- fix potential switch explit
-- improve user feedback on start

----------------
-- version 0.5
----------------
-- provision for variable minetimer / demo mines set to 5000ms
-- don't autoswitch if player only has 1 hog on his team

----------------
-- version 0.6
----------------
-- for the meanwhile, don't drop any crates except health crates

----------------
-- version 0.7
----------------
-- perhogadmsdf :D :D :D :D

--------------------
--TO DO
--------------------

-- balance hog health, maybe
-- add proper gameflag checking, maybe (so that we can throw in a .cfg and let the users break everything)

HedgewarsScriptLoad("/Scripts/Locale.lua")
HedgewarsScriptLoad("/Scripts/Tracker.lua")

local numhhs = 0
local hhs = {}

local started = false

local weapons =
	{amGrenade, amClusterBomb, amBazooka, amBee, amShotgun,
	amMine, amDEagle, amDynamite, amFirePunch, amWhip,
	amBaseballBat, amMortar, amKamikaze, amSeduction, amDrill,
	amSniperRifle, amMolotov, amBirdy, amGasBomb, amSineGun,
	amFlamethrower, amSMine, amHammer, amSnowball, amIceGun, 
	amKnife, amAirMine, amMinigun}

local utilities =
	{amPickHammer, amRope, amParachute, amBlowTorch, amGirder,
	amLowGravity, amExtraDamage, amInvulnerable, amExtraTime, amLaserSight,
	amVampiric, amJetpack, amPortalGun, amResurrector, amTardis,
	amLandGun, amRubber}

local amount = {
	[amRope] = 9,
	[amParachute] = 9,
	[amSeduction] = 9,
	[amSnowball] = 2,
	[amGirder] = 2,
	[amPortalGun] = 2,
	[amRubber] = 2
}

local randomweapon1 = {}
local randomweapon2 = {}
local randomutility = {}

local hoghealth = {}

function onNewAmmoStore(groupIndex, hogIndex)

	SetAmmo(amSkip, 9, 0, 0, 0)

	if not randomweapon1[hogIndex] then
		local random = 1+GetRandom(#weapons)
		randomweapon1[hogIndex] = weapons[random]
		table.remove(weapons, random)
	end

	if not randomweapon2[hogIndex] then
		local random = 1+GetRandom(#weapons)
		randomweapon2[hogIndex] = weapons[random]
		table.remove(weapons, random)
	end

	if not randomutility[hogIndex] then
		local random = 1+GetRandom(#utilities)
		randomutility[hogIndex] = utilities[random]
		table.remove(utilities, random)
	end

	if amount[randomweapon1[hogIndex]] then SetAmmo(randomweapon1[hogIndex], amount[randomweapon1[hogIndex]], 0, 0, 0)
	else SetAmmo(randomweapon1[hogIndex], 1, 0, 0, 0) end

	if amount[randomweapon2[hogIndex]] then SetAmmo(randomweapon2[hogIndex], amount[randomweapon2[hogIndex]], 0, 0, 0)
	else SetAmmo(randomweapon2[hogIndex], 1, 0, 0, 0) end

	if amount[randomutility[hogIndex]] then SetAmmo(randomutility[hogIndex], amount[randomutility[hogIndex]], 0, 0, 0)
	else SetAmmo(randomutility[hogIndex], 1, 0, 0, 0) end

end

function CreateTeam()

	currTeam = ""
	lastTeam = ""
	z = 0

	for i = 0, (numhhs-1) do

			currTeam = GetHogTeamName(hhs[i])

			if currTeam == lastTeam then
					z = z + 1
			else
					z = 1
			end

			if not hoghealth[z] then hoghealth[z] = 80+GetRandom(13)*10 end
			SetHealth(hhs[i], hoghealth[z])

			if z == 1 then

					SetHogName(hhs[i],loc("Soldier"))
					SetHogHat(hhs[i], "sf_vega")

			elseif z == 2 then

					SetHogHat(hhs[i], "Glasses")
					SetHogName(hhs[i],loc("Engineer"))

			elseif z == 3 then

					SetHogName(hhs[i],loc("Ninja"))
					SetHogHat(hhs[i], "NinjaFull")

			elseif z == 4 then

					SetHogName(hhs[i],loc("Demo"))
					SetHogHat(hhs[i], "Skull")

			elseif z == 5 then

					SetHogName(hhs[i],loc("Sniper"))
					SetHogHat(hhs[i], "Sniper")

			elseif z == 6 then

					SetHogName(hhs[i],loc("Saint"))
					SetHogHat(hhs[i], "angel")

			elseif z == 7 then

					SetHogName(hhs[i],loc("Pyro"))
					SetHogHat(hhs[i], "Gasmask")

			elseif z == 8 then

					SetHogName(hhs[i],loc("Loon"))
					SetHogHat(hhs[i], "clown")

			end

			lastTeam = GetHogTeamName(hhs[i])

	end

end

function onGameInit()
	ClearGameFlags()
	EnableGameFlags(gfRandomOrder, gfResetWeps, gfInfAttack, gfPlaceHog, gfPerHogAmmo, gfSwitchHog)
	Delay = 10
	HealthCaseProb = 100
end

function onGameStart()

	CreateTeam()

	ShowMission     (
                                loc("THE SPECIALISTS"),
                                loc("a Hedgewars mini-game"),

                                loc("Eliminate the enemy specialists.") .. "|" ..
                                " " .. "|" ..

                                loc("Game Modifiers: ") .. "|" ..
                                loc("Per-Hog Ammo") .. "|" ..
                                loc("Weapons Reset") .. "|" ..
                                loc("Unlimited Attacks") .. "|" ..

                                "", 4, 4000
                                )

	trackTeams()

	if randomweapon1[0] then WriteLnToChat(loc("Soldier")..": "..GetAmmoName(randomweapon1[0])..", "..GetAmmoName(randomweapon2[0])..", "..GetAmmoName(randomutility[0])) end
	if randomweapon1[1] then WriteLnToChat(loc("Engineer")..": "..GetAmmoName(randomweapon1[1])..", "..GetAmmoName(randomweapon2[1])..", "..GetAmmoName(randomutility[1])) end
	if randomweapon1[2] then WriteLnToChat(loc("Ninja")..": "..GetAmmoName(randomweapon1[2])..", "..GetAmmoName(randomweapon2[2])..", "..GetAmmoName(randomutility[2])) end
	if randomweapon1[3] then WriteLnToChat(loc("Demo")..": "..GetAmmoName(randomweapon1[3])..", "..GetAmmoName(randomweapon2[3])..", "..GetAmmoName(randomutility[3])) end
	if randomweapon1[4] then WriteLnToChat(loc("Sniper")..": "..GetAmmoName(randomweapon1[4])..", "..GetAmmoName(randomweapon2[4])..", "..GetAmmoName(randomutility[4])) end
	if randomweapon1[5] then WriteLnToChat(loc("Saint")..": "..GetAmmoName(randomweapon1[5])..", "..GetAmmoName(randomweapon2[5])..", "..GetAmmoName(randomutility[5])) end
	if randomweapon1[6] then WriteLnToChat(loc("Pyro")..": "..GetAmmoName(randomweapon1[6])..", "..GetAmmoName(randomweapon2[6])..", "..GetAmmoName(randomutility[6])) end
	if randomweapon1[7] then WriteLnToChat(loc("Loon")..": "..GetAmmoName(randomweapon1[7])..", "..GetAmmoName(randomweapon2[7])..", "..GetAmmoName(randomutility[7])) end

	ParseCommand("history")

end


function onNewTurn()

	started = true
	AddCaption(loc("Prepare yourself") .. ", " .. GetHogName(CurrentHedgehog).. "!")

end

function onGearAdd(gear)

    if GetGearType(gear) == gtHedgehog then
		hhs[numhhs] = gear
		numhhs = numhhs + 1
	elseif (GetGearType(gear) == gtMine) and (started == true) then
		SetTimer(gear,5000)
	end

	if (GetGearType(gear) == gtHedgehog) or (GetGearType(gear) == gtResurrector) then
		trackGear(gear)
	end

end

function onGearDelete(gear)
	if (GetGearType(gear) == gtHedgehog) or (GetGearType(gear) == gtResurrector) then
		trackDeletion(gear)
	end
end

